load definitions.rex;

(********************************************************)
(* nth(succ(0),Cons(a,Cons(b,Nil))) -> nth(b) *)
genrule(nth(0,Cons(var(c),var(n))),resultchar(var(c)));
genrulecond(nth(var(i),Cons(var(c),var(n))),nth(minus(var(i),1),var(n)),gt(var(i), 0));
(********************************************************) 

(* xappend(Cons(a,Nil),Cons(b,Nil)) -> Cons(a,Cons(b,Nil)) *)
genrule(xappend(Nil,var(x)),var(x));
genrule(xappend(Cons(var(x),var(y)),var(z)),appendrev(var(x),xappend(var(y),var(z))));
genrule(appendrev(var(x),Cons(var(y),var(z))),Cons(var(x),Cons(var(y),var(z))));

(**********************************************************)
(* subseq(succ(0),Cons(a,Cons(b,Nil))) -> Cons(b,Nil) *)
genrule(subseq(0,var(x)),resultcons(var(x)));
genrulecond(subseq(var(i),Cons(var(x),var(y))),subseq(minus(var(i),1),var(y)),gt(var(i),0));
(**********************************************************)

(* appendstring(Str(sz1,s1),Str(sz2,s2)) -> resultstring(result(sz1+sz2),s1^s2) *)
genrule(
  appendstring(Str(var(sz1),var(c1)),Str(var(sz2),var(c2))),
  resultstring(plus(var(sz1),var(sz2)),xappend(var(c1),var(c2)))
);

(* substring(Str(sz,Cons(a,Cons(b,Nil))),succ(0)) -> resultstring(result(sz-1),resultcons(Cons(b,Nil))) *)
genrule(
  substring(Str(var(sz),var(c1)),var(i)),
  resultstring(minus(var(sz),var(i)),subseq(var(i),var(c1)))
);

(* java.lang.String concat *)
genrule(
  state(threadlist(thread(var(tl),frame(name(Method(<concat>,ConsType(OType($java_lang_string),NilType),
  OType($java_lang_string)),$java_lang_string),pp0,
  var(s0),locals($local_vars)),callstack(storedframe(var(m),var(pc),var(s),var(l)),var(f))),var(ntl)),
  var(h),var(k),var(tc)),
  state(threadlist(thread(var(tl),xframe(appendstring(var(l0),var(l1)),var(m),var(pc),var(s),var(l)),
  var(f)),var(ntl)),var(h),var(k),var(tc))
);
genrule(
  state(threadlist(thread(var(tl),xframe(resultstring(result(var(sz)),Cons(var(x),var(y))),
  var(m),var(pc),var(s),var(l)),var(f)),var(ntl)),var(h),var(k),var(tc)),
  state(threadlist(thread(var(tl),frame(var(m),next(var(pc)),stack(Str(var(sz),Cons(var(x),var(y))),
  var(s)),var(l)),var(f)),var(ntl)),var(h),var(k),var(tc))
);

(* java.lang.String charAt *)
genrule(
  state(threadlist(thread(var(tl),frame(name(Method(<charAt>,ConsType(TInt,NilType),TChar),$java_lang_string),pp0,
  var(s0),subsn(locals($local_vars),1,Str(var(sz),var(x)))),
  callstack(storedframe(var(m),var(pc),var(s),var(l)),var(f))),var(ntl)),var(h),var(k),var(tc)),
  state(threadlist(thread(var(tl),xframe(nth(var(l1),var(x)),var(m),var(pc),var(s),var(l)),var(f)),var(ntl)),
  var(h),var(k),var(tc))
);
genrule(
  state(threadlist(thread(var(tl),xframe(resultchar(var(x)),var(m),var(pc),var(s),var(l)),var(f)),var(ntl)),
  var(h),var(k),var(tc)),
  state(threadlist(thread(var(tl),frame(var(m),next(var(pc)),stack(var(x),var(s)),var(l)),var(f)),var(ntl)),
  var(h),var(k),var(tc))
);

(* java.lang.String length *)
genrule(
  state(threadlist(thread(var(tl),frame(name(Method(<length>,NilType,TInt),$java_lang_string),pp0,
  var(s0),subsn(locals($local_vars),1,Str(var(sz),var(x)))),
  callstack(storedframe(var(m),var(pc),var(s),var(l)),var(f))),var(ntl)),var(h),var(k),var(tc)),
  state(threadlist(thread(var(tl),frame(var(m),next(var(pc)),stack(var(sz),var(s)),var(l)),var(f)),var(ntl)),
  var(h),var(k),var(tc))
);

(* java.lang.String substring *)
genrule(
  state(threadlist(thread(var(tl),frame(name(Method(<substring>,ConsType(TInt,NilType),
  OType($java_lang_string)),$java_lang_string),pp0,var(s0),locals($local_vars)),
  callstack(storedframe(var(m),var(pc),var(s),var(l)),var(f))),var(ntl)),var(h),var(k),var(tc)),
  state(threadlist(thread(var(tl),xframe(substring(var(l0),var(l1)),var(m),var(pc),var(s),var(l)),var(f)),var(ntl)),
  var(h),var(k),var(tc))
);
genrule(
  state(threadlist(thread(var(tl),xframe(resultstring(result(var(sz)),resultcons(var(x))),var(m),var(pc),var(s),var(l)),
  var(f)),var(ntl)),var(h),var(k),var(tc)),
  state(threadlist(thread(var(tl),frame(var(m),next(var(pc)),stack(Str(var(sz),var(x)),var(s)),var(l)),
  var(f)),var(ntl)),var(h),var(k),var(tc))
);