open Terms_of_integer

let nilchar = "nilchar"

let term_of_char c =
  match c with
    | ' ' -> "space"
    | '(' -> "lp"
    | ')' -> "rp"
    | '[' -> "lb"
    | ']' -> "rb"
    | '{' -> "la"
    | '}' -> "ra"
    | '+' -> "plus"
    | '-' -> "minus"
    | '=' -> "equal"
    | '<' -> "inf"
    | '>' -> "sup"
    | '%' -> "percent"
    | '$' -> "dollar"
    | '*' -> "wildcar"
    | '.' -> "dot"
    | ',' -> "comma"
    | ';' -> "semicolon"
    | ':' -> "twopoints"
    | '~' -> "tilde"
    | '!' -> "exclamation"
    | '?' -> "interrogation"
    | '#' -> "sharp"
    | '\'' -> "apostrophe"
    | '\\' -> "backslash"
    | '/' -> "slash"
    | '|' -> "pipe"
    | '\"' -> "quote"
    | '^' -> "circumflex"
    | 'a'..'z' | 'A'..'Z' -> String.make 1 c
    | '0' -> "0"
    | '1' -> "1"
    | '2' -> "2"
    | '3' -> "3"
    | '4' -> "4"
    | '5' -> "5"
    | '6' -> "6"
    | '7' -> "7"
    | '8' -> "8"
    | '9' -> "9"
    | c when int_of_char c = 0 -> "nilchar"
    | _ -> "UnhandledCharacter"

let rec termlist_of_string l s =
  let len = String.length s in
    if (len > 0) then
      let t = term_of_char (s.[len - 1]) in
	termlist_of_string (t :: l) (String.sub s 0 (len - 1))
    else l


(***********NE DEVRAIT PAS GENERER DE ZERO => term_of_int remplac par string_of_int***********)

let term_of_string s =
  let l = termlist_of_string [] s
  and len = String.length s in
    if (len > 0) then
      "Str(" ^ (string_of_int len) ^ ",Cons(" ^ (String.concat ",Cons(" l)
      ^ ",Nil)" ^ (String.make len ')')
    else "Str(0,Nil)"
